#include "Ball.h"
#include "Ponger.h"

CPonger::CPonger(bool bPlayer)
{
	m_PongerShape.AddPoint(sf::Vector2f(0, 0));
	m_PongerShape.AddPoint(sf::Vector2f(0, 100));
	m_PongerShape.AddPoint(sf::Vector2f(50, 100));
	m_PongerShape.AddPoint(sf::Vector2f(50, 0));

	m_PongerShape.EnableFill(true);

	m_PongerRect.Top    = 0;
	m_PongerRect.Left   = 0;
	m_PongerRect.Right  = 50;
	m_PongerRect.Bottom = 100;

	this->Reset(bPlayer);

	m_bGegnerIsSecondPlayer=false;

	m_Clock.Reset();
}

void CPonger::Reset(bool bPlayer)
{
	m_PongerShape.SetPosition(((bPlayer==true)?25.f:725.f), 250.f);
	m_Position=sf::Vector2f(((bPlayer==true)?25.f:725.f), 250.f);
}

void CPonger::Render(sf::RenderWindow &rw)
{
	rw.Draw(m_PongerShape);
}

void CPonger::SetPosition(sf::Vector2f offset)
{
	m_Position.x += offset.x;
	if((m_Position.y<600)||(m_Position.y>0)) {m_Position.y += offset.y;}
	m_PongerShape.SetPosition(m_Position);
}

void CPonger::Update(bool bPlayer, sf::Event &Event, sf::RenderWindow &rw, CBall *pBall)
{
	m_fTime=m_Clock.GetElapsedTime();
	m_Clock.Reset();
	if(bPlayer) //Spieler
	{
		while(rw.GetEvent(Event))
		{
			if((Event.Type == sf::Event::KeyPressed)&&(Event.Key.Code==sf::Key::Up))
				this->SetPosition(sf::Vector2f(0, -5));
			else if((Event.Type == sf::Event::KeyPressed)&&(Event.Key.Code==sf::Key::Down))
				this->SetPosition(sf::Vector2f(0, 5));
		}
	}
	else //Gegner (KI/2Player)
	{
		while(rw.GetEvent(Event))
		{
			if((Event.Type == sf::Event::KeyPressed)&&((Event.Key.Code==sf::Key::W)||(Event.Key.Code==sf::Key::S)))
				m_bGegnerIsSecondPlayer=true;

			if(m_bGegnerIsSecondPlayer)
			{
				//2Player
				if((Event.Type==sf::Event::KeyPressed)&&(Event.Key.Code==sf::Key::W))
					this->SetPosition(sf::Vector2f(0, -5));
				else if((Event.Type==sf::Event::KeyPressed)&&(Event.Key.Code==sf::Key::S))
					this->SetPosition(sf::Vector2f(0, 5));
			}
			else
			{
				//KI
				sf::Vector2f tempvec = pBall->m_Position;
				if(tempvec.x<=300)
					if(tempvec.y!=m_Position.y)
						this->SetPosition(sf::Vector2f(0, ((m_Position.y<tempvec.y)?5.f:-5.f)));
			}
		}
	}
}